#!/usr/bin/php
<?php
$EXIT_SUCCESS=0;
$EXIT_NOT_IMPLEMENTED=-1;
$EXIT_ERROR=1;

$current_script = basename(__FILE__);

$lib_path = 'lib/php/backup/drivers';
$current_path = dirname(__FILE__);
$driver_path = "$current_path/$lib_path";

$options = getopt('A:M:O:S:');

if( $options['M'] == 'listfiles' )
{
	$files = glob('/home/esia/*.bck.conf');
	$ret = array();
	foreach($files as $file)
	{
		$matches = array();
		if( preg_match('#/home/esia/([^\.]+\.[^\.]+)\.bck\.conf#',$file,$matches) )
		{
			$ret[] = $matches[1];
		}
	}
	echo json_encode($ret,TRUE)."\n";
	exit($EXIT_SUCCESS);
}

foreach(array('M','O','S') as $key)
{
	if( !isset($options[$key]))
	{
		echo "$current_script : Parameter -$key is missing\n"; exit($EXIT_ERROR);
	}
}

$method = $options['M'];
$parameters = $options['O'];
if( !is_array($parameters) )
{
	$parameters = array($parameters);	
}

$script_file = $options['S'];
$authfile = $options['A'];
$authfile = "/home/esia/$authfile.bck.conf";

$exp = explode('-',$script_file);
$script_dir = $exp[0];

$options = '';
foreach($parameters as $key => $value){
   $options.= " -O $value";
}

$full_path = "$driver_path/$script_dir/$script_file";
$cmd = "$full_path -A $authfile -M $method $options";
exec($cmd,$output,$ret);
$output = implode("\n",$output);
echo "$output\n";
exit($ret);
