<?php
$EXIT_SUCCESS=0;
$EXIT_NOT_IMPLEMENTED=-1;
$EXIT_ERROR=1;

define('ECATP_PATH','/usr/local/esia/plugins/check_gesa');

function setSettings($required_parameters,&$action,&$options)
{
    $required_parameters = explode(',',$required_parameters);

    global $EXIT_ERROR;
    global $EXIT_NOT_IMPLEMENTED;

    $options = getopt('A:M:O:');
    if( !isset($options['M'])){
    	echo "Parameter -M is missing\n"; exit($EXIT_ERROR);
    }

    $METHOD=$options['M'];
    if(isset($options['O'])){
    	if(is_array($options['O'])){
    		$OPTIONS=$options['O'];
    	}
    	else{
    		$OPTIONS=array($options['O']);
    	}
    }
    else{
    	$OPTIONS=array();
    }

    $action = strtolower($METHOD);

    $AUTH_FILE = 'NULL';
    if(isset($options['A']) && is_readable($options['A'])){
        $AUTH_FILE = $options['A'];
    	$options = json_decode(file_get_contents($AUTH_FILE),true);
        if( $options === FALSE )
        {
                echo "Unable to decode auth JSON file $AUTH_FILE\n"; exit($EXIT_ERROR);
        }
    }
    else{
    	$options = array();
    }

    foreach($OPTIONS as $opt)
    {
    	$exp=explode('=',$opt);
    	$exp[0] = trim($exp[0]);
    	$exp[1] = trim($exp[1]);

    	if(count($exp) != 2 )
        {
    		echo "Incorrect Option -O format ($opt) must have format -O <name>=<value> -O <name>=<value> ... \n"; exit($EXIT_ERROR);
    	}
    	if( isset($options[$exp[0]]) )
        {
    		echo "Option -O $opt overwrite another options parameter or auth file option\n"; exit($EXIT_ERROR);
    	}
	    $options[$exp[0]]=$exp[1];
    }

    foreach($required_parameters as $rp)
    {
        if( empty($options[$rp]) )
        {
            echo "JSON file $AUTH_FILE hasn't required '$rp' parameter\n";
            exit($EXIT_ERROR);
        }
    }
}

function unityRun($plugin_bin,$action,$options,&$output,&$ret)
{
    $gesasn = $options['gesasn'];
    unset($options['gesasn']);

    $parameters = "-S $plugin_bin -M $action";
    foreach($options as $key => $value){
        $parameters.= " -O $key=$value";
    }

    $cmd = ECATP_PATH . " -G $gesasn -C ". 'get-backup.php' . ' -A ' ."'$parameters'";
    for($i=0;$i<3;$i++){ //problème ecatp
        $output = array();
        usleep($i*500);
        exec($cmd,$output,$ret);
        if( $ret != 0 ) {
            $success=false;
        }
        else{
            $success=true;
            break;
        }
    }

    $output = implode("\n",$output);
    return $success;
}


function period($start)
{
    $start = strtolower($start);
    if(preg_match('/^[-]?(\d+)([hdwmy]?)$/',$start,$matches)){
            if(!empty($matches[2])){
                    $matches[2]=strtoupper($matches[2]);
                    switch($matches[2]){
                            case 'H' :
                                    $since = time() - $matches[1] * 3600;
                                    break;
                            case 'D' :
                                    $since = time() - $matches[1] * 86400;
                                    break;
                            case 'W' :
                                    $since = time() - $matches[1] * 604800;
                                    break;
                            case 'M' :
                                    $date = new DateTime();
                                    $date->sub(new DateInterval('P'.$matches[1].$matches[2]));
                                    $since=$date->format('U');
                                    break;
                            case 'Y' :
                                    $date = new DateTime();
                                    $date->sub(new DateInterval('P'.$matches[1].$matches[2]));
                                    $since=$date->format('U');
                                    break;
                    }
            }
            else $since = $matches[1];
    }
    else throw new Exception();
    return $since;
}

function period_to_hour($start){
    $since = period($start);
    $hours = ( time() - $since ) / 3600;
	return intval($hours);
}

function period_to_date($start){
    $since = period($start);
    return date('Y-m-d H:i:s',$since);
}

function period_to_ts($start)
{
    return date('U',period($start));
}
