#!/usr/bin/php
<?php
define('PLUGIN_BIN',basename(__FILE__));

include_once('ProxmoxBackupClient.class.php');
include_once('/usr/local/esia/plugins/lib/php/backup/drivers/common/common.lib.php');

setSettings('url,username,token_name,token_value',$action,$options);

//Si on à l'options gesasn, c'est qu'on doit passer à travers une unity
if( isset($options['gesasn'])){
	$output = array();
	$ret = NULL;
	$success = unityRun(PLUGIN_BIN,$action,$options,$output,$ret);
	echo $output;
	exit($ret);
}

$result = array();
switch($action){
	case 'getjobsids' :
		$ret = getJobsIDS($result,$options);
		break;
	case 'getjobsvalues' :
		$ret = getJobsInfos($result,$options);
		break;
	default :
		echo "Method $action not implemented\n"; exit($EXIT_NOT_IMPLEMENTED);
}
echo json_encode($result,JSON_PRETTY_PRINT)."\n";
exit($ret);

function getJobsIds(&$result,$options)
{
	$period_ts = period_to_ts($options["period"]);

	$client = new ProxmoxClient($options);
	$client->open();
	$datastores = $client->get('admin/datastore');
	$backups_list = array();
	foreach($datastores as $store)
	{
		$ds_name = $store['store'];
		$backups = $client->get("admin/datastore/$ds_name/snapshots");
		foreach($backups as $backup)
		{
			$backup_id = $backup['backup-id'];
			$backup_ts = $backup['backup-time'];
			if( date_between($backup_ts,$period_ts,time()))
			{
				$backups_list[] = "$ds_name:$backup_id:$backup_ts";
			}
		}
	}
	$client->close();
	$result['ids'] = $backups_list;
	return $GLOBALS['EXIT_SUCCESS'];
}

function getJobsInfos(&$result,$options)
{
	$client = new ProxmoxClient($options);
	$client->open();

	$ids_list = explode(',',$options['ids']);

	$result = array();
	$data = array();
	foreach($ids_list as $id)
	{
		$exp = explode(':',$id);
		if( !isset($exp[2]))
		{
			continue;
		}
		$ds_name = $exp[0];
		$backup_id = $exp[1];
		$backup_ts = $exp[2];
		if( !isset($data[$ds_name][$backup_id] ) )
		{
			$tmp = $client->get("admin/datastore/$ds_name/snapshots?backup-id=$backup_id");
			foreach($tmp as $row)
			{
				$data[$ds_name][$backup_id][$row['backup-time']] = $row;
			}
		}

		$current = $data[$ds_name][$backup_id][$backup_ts ];
		$retRow['intern_id'] 	= $id;
		$retRow['name'] 	= $current['backup-id'];
		$retRow['status_backup'] = 'Not verified';
		if( isset($current['verification']['state']) )
		{
                	$retRow['status_backup'] = $current['verification']['state'];
		}
		if( $retRow['status_backup'] == 'ok' || $retRow['status_backup'] == 'Not verified')
		{
                	$retRow['status_esia']  = 0;
		}
		else
		{
			 $retRow['status_esia'] = 2;
		}
                $retRow['start_time'] 	= $current['backup-time'];
                $retRow['end_time'] 	= $current['backup-time'];
                $retRow['size'] 	= $current['size'];
                $retRow['type'] 	= $current['backup-type'];
		$retRow['source']       = $current['backup-id'];
                $retRow['storage'] 	= $ds_name;

		$result[] = $retRow;
	}
	$client->close();
}

function date_between($date,$since,$last=null){
	if( $date === false || $since == false || $last == false) return false;
	if( $date < $since ) return false;
	if( $date > $last  ) return false;
	return true;
}
