#!/usr/bin/php
<?php
include_once('/usr/local/esia/plugins/lib/php/backup/drivers/common/common.lib.php');
define('PLUGIN_BIN',basename(__FILE__));

setSettings('host,dbname,dbuser,dbpass',$action,$options);

//Detection auto du dbdriver (dblib par défaut)
if( empty($options['dbdriver']) )
{
	$host = $options['host'];
	$dbport = $options['port'];

	$exp = explode(':',$host);
	if( isset($exp[1]) )
	{
		$pdo_drv = $exp[0];
		$host = $exp[1];
	}
	else if( $dbport == 5432 )
	{
		$pdo_drv = 'pgsql';
	}
	if( !isset($pdo_drv) || $pdo_drv != 'pgsql' )	{
		$pdo_drv = 'dblib';
	}
	$options['dbdriver'] = $pdo_drv;
	$options['host'] = $host;
}

//Si on à l'options gesasn, c'est qu'on doit passer à travers une unity
if( isset($options['gesasn']))
{
	$output = array();
	$ret = NULL;
	$success = unityRun(PLUGIN_BIN,$action,$options,$output,$ret);
	echo $output;
	exit($ret);
}

switch($action){
	case 'getjobsids' :
		$ret = getJobs($result,$options);
		break;
	case 'getjobsvalues' :
		$ret = getJobsValues($result,$options,true);
		break;
	default :
		echo "Method $action not implemented\n"; exit($EXIT_NOT_IMPLEMENTED);
}

echo json_encode($result)."\n";
exit($ret);

function getJobsByStatus($options,$where_status){
	$pdo_drv = $options['dbdriver'];
	if( $pdo_drv == 'pgsql' )
	{
		$request = 'SELECT sv.id FROM "backup.model.backuptasksessions" sv';
		$request.= " WHERE $where_status";
	}
	else
	{
		$request = 'SELECT sv.id FROM [Backup.Model.BackupTaskSessions] sv';
		$request.= " WHERE $where_status";
	}

	if(isset($options['period'])){
		$date = period_to_date($options['period']);
		$request.= " AND sv.creation_time>='$date'";
	}
	if( isset($options['except'] )){
		$except = explode(',',$options['except']);
		$arr = array();
		foreach($except as $ex){
			$ex=trim($ex,"'");
			$arr[]="'$ex'";
		}
		$except = implode(',',$arr);
		$request.= " AND sv.id NOT IN($except)";
	}

	$response = execute_request($options,$request);
	$ids = array();
	foreach($response as $row){
		$ids[]=$row['id'];
	}
	return $ids;
}

function getJobs(&$result,$options){
	if( isset($options['status']) && strtolower($options['status']) != 'all'){
		$status = explode(',',$options['status']);
		$jobs = array();
		foreach($status as $st){
			if( $st == 0 ){ //OK
				$where = 'sv.status NOT IN(2,3)';
				$jobs = array_merge($jobs,getJobsByStatus($options,$where));
			}
			else if($st == 1 ){ // WARN
				$where = 'sv.status = 3';
				$jobs = array_merge($jobs,getJobsByStatus($options,$where));
			}
			else if($st == 2 ){
				$where = 'sv.status = 2'; //CRITIC
				$jobs = array_merge($jobs,getJobsByStatus($options,$where));
			}
		}
	}
	else {
		$jobs = getJobsByStatus($options,'sv.status >= 0'); //Tous les status sont plus grand que 0
	}

	$result['ids']=$jobs;
	return $GLOBALS['EXIT_SUCCESS'];
}

function getJobsValues(&$result,$options){
	if( isset($options['ids']) ){
		$jobsids = explode(',',$options['ids']);
		$arr = array();
		foreach($jobsids as $ex){
			$ex=trim($ex,"'");
			$arr[]="'$ex'";
		}
		$jobsids = implode(',',$arr);
	}
	else{
		echo "Parameter ids is missing\n";
		exit($GLOBALS['EXIT_ERROR']);
	}

	$pdo_drv = $options['dbdriver'];
	if( $pdo_drv == 'pgsql' )
	{
		$table_backupTaskSessions = '"backup.model.backuptasksessions"';
		$table_jobSessions = '"backup.model.jobsessions"';
	}
	else
	{
		$table_backupTaskSessions = '[Backup.Model.BackupTaskSessions]';
		$table_jobSessions = '[Backup.Model.JobSessions]';
	}
	$request = "SELECT ";
	$request.= "sv.id AS id,";
	$request.= "js.job_name AS name,";
	$request.= "sv.object_name AS source,";
	$request.= "sv.stored_size AS size,";
	$request.= "(CASE js.job_type WHEN 0 THEN 'BACKUP' WHEN 1 THEN 'REPLICATION' WHEN 51 THEN 'COPY JOB'ELSE 'UNKNOWN' END) AS type,";
	$request.= "(CASE sv.status WHEN 0 THEN 'Success' WHEN 2 THEN 'Error' WHEN 3 THEN 'Warning' ELSE 'Success' END) AS status,";
	$request.= "sv.reason AS reason,";
	$request.= "sv.creation_time AS start_time,";
	$request.= "sv.end_time AS end_time";

	$request.= " FROM $table_backupTaskSessions sv INNER JOIN $table_jobSessions js ON sv.session_id = js.id";
	$request.= " WHERE sv.id IN($jobsids)";

	$response = execute_request($options,$request);
	$result = array();
	foreach($response as $row){
		$jobs['intern_id']	= $row['id'];
		$jobs['name'] 		= $row['name'];
		$jobs['source'] 	= $row['source'];
		$jobs['size'] 		= $row['size'];
		$jobs['type'] 		= $row['type'];

		switch(strtolower(trim($row['status']))){
			case 'success' :
				$jobs['status_esia'] = 0;
				break;
			case 'warning' :
				$jobs['status_esia'] = 1;
				break;
			case 'error' :
				$jobs['status_esia'] = 2;
				break;
		}

		if(empty($row['reason'])){
			$jobs['status_backup'] = $row['status'];
		}
		else{
			$jobs['status_backup'] = $row['status'] . " : " . $row['reason'];
		}

		$jobs['start_time'] = date_format(new DateTime($row['start_time']),'U');
		$jobs['end_time'] = date_format(new DateTime($row['end_time']),'U');
		if( $jobs['end_time'] < 0 ) $jobs['end_time'] = NULL;

		$result[] = $jobs;
	}
	return $GLOBALS['EXIT_SUCCESS'];
}

function execute_request($options,$request){
	//Mode mssql instance
	if(isset($options['dbinstance'])){
		$host = $options['host'];
		$dbinstance = $options['dbinstance'];
		$dbuser = $options['dbuser'];
		$dbpass = $options['dbpass'];
		$dbname = $options['dbname'];

		try{
		        $db=new PDO("dblib:host=${host}\\${dbinstance};database=${dbname}", $dbuser, $dbpass);
		        $db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);
		        $db->setAttribute(\PDO::DBLIB_ATTR_STRINGIFY_UNIQUEIDENTIFIER, true);

		        $sth=$db->prepare($request);
		        $ret = $sth->execute();
				if($ret === FALSE)
				{
				        $err = $sth->errorInfo();
				        throw new Exception($err[2]);
				}

		        $ret = array();
		        while($row=$sth->fetch(PDO::FETCH_ASSOC))
		        {
                                $ret[] = $row;

		        }
		        return $ret;
	        }
	        catch(Exception $ex){
		        echo "DB access or SQL ERROR : ".$ex->getMessage()."\n"; exit($GLOBALS['EXIT_ERROR']);
	        }
	}

	//Mode with port 1433 or 5432 or pgsql dbdriver
	$host = $options['host'];
	$dbname = $options['dbname'];
	$dbuser = $options['dbuser'];
	$dbpass = $options['dbpass'];
	$dbport = $options['port'];

	//print_r($options);

	try{
		$pdo_drv = $options['dbdriver'];
		if( $pdo_drv == 'pgsql' )
		{
			//echo "pgsql:host=$host:$dbport;dbname=$dbname\n";
			$db = new PDO("pgsql:host=$host;port=$dbport;dbname=$dbname",$dbuser,$dbpass);
		}
		else
		{
			//echo "dblib:version=7.0;charset=UTF-8;host=$host:$dbport;dbname=$dbname\n";
			$db = new PDO("dblib:version=7.0;charset=UTF-8;host=$host:$dbport;dbname=$dbname",$dbuser,$dbpass);
		}
		$db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);
		$db->setAttribute(\PDO::DBLIB_ATTR_STRINGIFY_UNIQUEIDENTIFIER, true);

		$sth=$db->prepare($request);
		$ret = $sth->execute();
		if($ret === FALSE)
		{
				$err = $sth->errorInfo();
				throw new Exception($err[2]);
		}

		$ret = array();
		while($row=$sth->fetch(PDO::FETCH_ASSOC))
		{
			$ret[]=$row;
		}
		return $ret;
	}
	catch(Exception $ex){
		echo "DB access or SQL ERROR : ".$ex->getMessage()."\n"; exit($GLOBALS['EXIT_ERROR']);
	}
}
?>
