<?php
include_once '/usr/local/esia/plugins/lib/php/HTTP.class.php';

class VeeamClient extends ESIA\HTTP\HttpClient
{
	protected $driverSettings;
	protected $is_open = FALSE;

	public function __construct($settings)
	{
		$this->driverSettings = $settings;
		$url = $settings['url'];

		$api_version = $settings['api_version'];
		$path_prefix = "$api_version";
		$url = "$url/$path_prefix";
		parent::__construct($url);

		$this->setOptions(CURLOPT_CONNECTTIMEOUT,5);
		$this->setOptions(CURLOPT_TIMEOUT,20);
	}

	public function open()
	{
		$settings = $this->driverSettings;
		$params = array();
		$params['grant_type']='password';
		$params['disable_antiforgery_token']='true';
		$params['username'] = $settings['username'];
		$params['password'] = $settings['password'];

		$header = array();
		$header[] = 'application/x-www-form-urlencoded';

		parent::open();

		$this->setoptions(CURLOPT_HTTPHEADER,$header);
		$data = $this->post('/token',$params);
		$token = $data['access_token'];
		$header = array();
		$header[] = "Authorization: Bearer $token";
		$this->setoptions(CURLOPT_HTTPHEADER,$header);
		$this->is_open = TRUE;
	}

	public function execute_request($options = null)
	{
		$data = parent::execute_request($options);
		$ret = $this->getHttpCode();
		if ( !in_array($ret,array(200,201,204)))
		{
			$data = json_decode($data,TRUE);
			if( !empty($data['message']) )
			{
				throw new Exception("Error code $ret : ".$data['message']);
			}
			else
			{
				throw new Exception("Error code $ret : No message");
			}
		}

		if (empty ($data))
		{
			return NULL;
		}
		$data = json_decode($data, TRUE);
		if ($data === FALSE)
		{
			throw new Exception('Unable to parse json response');
		}
		return $data;
	}

	public function isOpen()
	{
		return $this->is_open;
	}

	public function close()
	{
		$this->post('/token/logout',array());
		parent::close();
		$this->is_open = FALSE;
	}
}
