<?php
namespace ESIA\Convert;
use Exception;
{
    function genericConvert($units_list,$size,$bytes,$precision=0,$unity='BB')
    {
        $enterbyte = $bytes;
        $i = 0;

        if( $unity == 'BB' )
        {
            while ($enterbyte > $size)
            {
                $enterbyte = $enterbyte / $size;
                $i++;
            }
        }
        else if( !in_array($unity,$units_list))
        {
            throw new Exception("Invalid unit : $unity. Not found into array (".implode(',',$units_list). ")" );
        }
        else
        {
            while($units_list[$i] != $unity)
            {
                $enterbyte = $enterbyte / $size;
                $i++;
            }
        }

        $human = round($enterbyte, $precision);
        return array('value'=>$human,'unity'=>$units_list[$i]);
    }

    function genericConvertToHuman($units_list,$size,$usage,$total,$precision=0,$throwifzero=TRUE)
    {
        $free = $total-$usage;
	$ret['raw']['usage'] = $usage;
	$ret['raw']['free']  = $free;
	$ret['raw']['total'] = $total;

	if( $total == 0 )
	{
		if( $throwifzero )
		{
			throw new Exception("Unable to calculate percentages because total value is 0 and cause divide by 0.");
		}
		$total = $usage;
	}
	if( $total == $usage )
	{
        	$ret['percent']['usage'] = 100;
        	$ret['percent']['free']  = 0;
	}
	else
	{
	        $ret['percent']['usage'] = round(($usage/$total)*100,$precision);
        	$ret['percent']['free']  = round(($free/$total)*100,$precision);
	}


	$data = genericConvert($units_list,$size,$total,$precision);
	$ret['human']['unit'] = $data['unity'];
	$ret['human']['usage']  = genericConvert($units_list,$size,$usage,$precision,$data['unity'])['value'];
	$ret['human']['free']  = genericConvert($units_list,$size,$free,$precision,$data['unity'])['value'];
	$ret['human']['total']  = $data['value'];
	return $ret;
    }

    function bytes($bytes,$precision=0,$unity='BB')
    {
        $units = ['', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
        return genericConvert($units,1024,$bytes,$precision,$unity);

    }
    function bits($bytes,$precision=0,$unity='BB')
    {
    	$units = ['', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb', 'Zb', 'Yb'];
		return genericConvert($units,1000,$bytes,$precision,$unity);
    }

    function bitsPerSecond($bytes,$precision=0,$unity='BB')
    {
        $units = ['b/s', 'Kb/s', 'Mb/s', 'Gb/s', 'Tb/s', 'Pb/s', 'Eb/s', 'Zb/s', 'Yb/s'];
		return genericConvert($units,1000,$bytes,$precision,$unity);
    }

    function bytesToHuman($usage,$total,$precision=0,$throwifzero=TRUE)
    {
		$units = ['', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
		return genericConvertToHuman($units,1024,$usage,$total,$precision,$throwifzero);
    }

    function bitsToHuman($usage,$total,$precision=0,$throwifzero=TRUE)
    {
		$units = ['', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb', 'Zb', 'Yb'];
		return genericConvertToHuman($units,1000,$usage,$total,$precision,$throwifzero);
    }

    function bitsPerSecondToHuman($usage,$total,$precision=0,$throwifzero=TRUE)
    {
         $units = ['b/s', 'Kb/s', 'Mb/s', 'Gb/s', 'Tb/s', 'Pb/s', 'Eb/s', 'Zb/s', 'Yb/s'];
         return genericConvertToHuman($units,1000,$usage,$total,$precision,$throwifzero);
    }
}
