#!/usr/bin/php
<?php
$START_SCRIPT = time();

define('PATH','/usr/local/esia/public_html/plugin/virtualization/drivers');
$_SERVER['DOCUMENT_ROOT']=PATH;
chdir(PATH);

// dossier courant
echo getcwd() . "\n";
include_once "/usr/local/esia/public_html/plugin/virtualization/drivers/hyperv/HyperV.class.php";

echo "Instantiate class device\n";
$dev = new Device();

echo "Instanciate and test Proxmox Cluster\n";


$o_file = '/tmp/auth/virt_61.dat';
$settings = file_get_contents($o_file);
$settings = json_decode($settings,TRUE);
$hypervList['vsrv-hyperV-1'] = new HypervClient($settings);


$o_file = '/tmp/auth/virt_62.dat';
$settings = file_get_contents($o_file);
$settings = json_decode($settings,TRUE);
$hypervList['vsrv-hyperV-2'] = new HypervClient($settings);


$showData = false;
//CACHE
HypervClient::$PERMANENT_TIME=1800;  //1h
HypervClient::$LONG_TIME=300;   //5 min
HypervClient::$SHORT_TIME=60; //1 min

HypervClient::$MIN_DIFF_TIME=300; //1 min

foreach($hypervList as $name => $client)
{
	echo "**************** $name ****************\n";
	echo "RUN getCluster\n";
	$start = time();
	try
	{
		$data = $client->getCluster();
		if( $showData ) print_r($data['data']);
		$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";
	}
	catch(Exception $ex)
	{
		echo 'ERROR :'.$ex->getMessage()."\n";
		continue;
	}

	echo "RUN getHostList\n";
	$start = time();
	$data = $client->getHostList();
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getHostValues\n";
	$start = time();
	$data = $client->getHostValues($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getHostInterfaces\n";
	$start = time();
	$data = $client->getHostInterfaces($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getHostCPU\n";
	$start = time();
	$data = $client->getHostCPU($name);
	if( $showData ) var_dump($data);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getHostBandwidth\n";
	$start = time();
	$data = $client->getHostBandwidth($name);
	if( $showData ) print_r($data);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";


	echo "RUN getSRList\n";
	$start = time();
	$data = $client->getSRList($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getSRVHD\n";
	$start = time();
	$data = $client->getSRVHD($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getSRPath\n";
	$start = time();
	$data = $client->getSRPath($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getVMList\n";
	$start = time();
	$data = $client->getVMList($name);
	if( $showData ) print_r($data);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";
	$vmlist = $data['data'];

	echo "RUN getVMValues\n";
	$start = time();
	$data = $client->getVMValues($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

	echo "RUN getVMMetrics\n";
	$start = time();
	$data = $client->getVMMetrics($name);
	if( $showData )
	{
		echo implode(',',(array_keys($data['data']['0'])))."\n";
		foreach($data['data'] as $row)
		{
			echo $row['VMName'] .' ' . $row['MeteringDuration']['TotalSeconds']. " seconds\n";
		}
	}
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

/*
	foreach($vmlist as $vm)
	{
		$vmname = $vm['name'];
		echo "**************** VM:$vmname ****************\n";
		echo "RUN getVMAgent\n";
		$start = time();
		$data = $client->getVMAgent($vmname);
		if( $showData ) var_dump($data['data']['is_agent']);
		$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";

		if( $vm['ha_settings'])
		{
			echo "RUN getVMHASettings\n";
			$start = time();
			$data = $client->getVMHASettings($vmname);
			if( $showData ) print_r($data['data']);
			$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";
		}
	}
*/


	echo "RUN getVMSnapshots\n";
	$start = time();
	$data = $client->getVMSnapshots($name);
	if( $showData ) print_r($data['data']);
	$end = time(); $time = $end-$start; $start = $end; echo "exec time $time\n\n";
}
$END_SCRIPT = time();
$TIME = $END_SCRIPT - $START_SCRIPT;
echo "SCRIPT EXEC TIME : $TIME\n";
