$toRet = @{}
$win32_os = Get-WmiObject -ComputerName $ComputerName -Class Win32_OperatingSystem
$win32_cpu = Get-CimInstance -ComputerName $ComputerName -ClassName Win32_Processor | Select-Object -Property NumberOfCores, NumberOfLogicalProcessors;

$toRet.id = $ComputerName
$toRet.ComputerName = $win32_os.CSName
$toRet.description = $win32_os.Description
$toRet.os = $win32_os.Caption
$toRet.os_version = $win32_os.Version


$toRet.cpu_cores = $win32_cpu.NumberOfCores
$toRet.cpu_logical = $win32_cpu.NumberOfLogicalProcessors

#$toRet.address = [System.Net.Dns]::GetHostByName($env.COMPUTERNAME).AddressList[0].IPAddressToString

$toRet.uptime = (get-date) - $win32_os.ConvertToDateTime($win32_os.LastBootUpTime)
$toRet.uptime = [math]::Floor($toRet.uptime.TotalSeconds)
$toRet.mem_total = $win32_os.TotalVisibleMemorySize
$toRet.mem_usage = $win32_os.TotalVisibleMemorySize - $win32_os.FreePhysicalMemory
$toRet
