$clusterNode = Get-ClusterNode

$retList = @()
foreach( $node in $clusterNode )
{
    $toRet = @{}
    $toRet.Id = $node.Id
    $toRet.UniqueID = $node.UniqueID
    $toRet.Name = $node.Name
	$toRet.Description = $node.Description 

	$toRet.State = $node.State | Out-String
	$toRet.StatusInformation = $node.StatusInformation | Out-String
	$toRet.Type = $node.Type | Out-String 	

	$toRet.MajorVersion = $node.MajorVersion 
	$toRet.MinorVersion = $node.MinorVersion 
    $toRet.Cluster = $node.Cluster.Name

 #   $toRet.ipconf = Get-NetIPConfiguration 
    $toRet.address = ([System.Net.Dns]::GetHostByName($toRet.Name).AddressList | Where-Object { $_ -notmatch '^169\.' }|Sort-Object).IPAddressToString 
    if ( $toRet.address -is [array]) 
    {
    	$toRet.mainAddress = $toRet.address[0]
    }
    else
    {
	$toRet.mainAddress = $toRet.address
	$toRet.address = @($toRet.address)
    }


	#$toRet.VMHOST = Get-VMHost -ComputerName $toRet.ComputerName | Select-object LogicalProcessorCount,MemoryCapacity,VirtualMachineMigrationEnabled,InternalNetworkAdapters,ExternalNetworkAdapters
	#$toRet.InternalNetworkAdapters = $toRet.VMHOST.InternalNetworkAdapters | Select-object *
	#$toRet.ExternalNetworkAdapters = $toRet.VMHOST.ExternalNetworkAdapters | Select-object *
	#$toRet.one = Get-ComputerInfo

    $retList+=$toRet
}
$retList

